// PHF2BIN.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "PHF2BIN.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include <stdio.h>


// The one and only application object

CWinApp theApp;

using namespace std;

#define	BUFSIZE	4096

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0, headerDone = 0;
	HANDLE hIn, hOut;
	DWORD nRead, nWritten, cksum, fCksum, slen;
	DWORD nBytes, page, disp, sect, map, toAddr, vAddr, vLen, dummyLen;
	LPVOID buf, dummy = NULL;
	UCHAR *ptr;
	LPSTR tstr, eptr;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		_tprintf(_T("Fatal Error: MFC initialization failed\n"));
		nRetCode = 1;
	}
	else
	{
		if ((buf = malloc(BUFSIZ)) == NULL) {
			_tprintf(_T("Memory allocation error\n"));
			nRetCode = 1;
			return nRetCode;
		}

		// Initialize work variables.
		nRead = nWritten = cksum = fCksum = 0;
		slen = 0;
		map = 0;
		toAddr = vAddr = vLen = dummyLen = 0;
		ptr = (UCHAR*)buf;

		hIn = GetStdHandle(STD_INPUT_HANDLE);
		hOut = GetStdHandle(STD_OUTPUT_HANDLE);

		while (ReadFile(hIn, ptr, BUFSIZE - nRead, &nRead, NULL)) {
			if (!nRead)
				break;
			nRead += (DWORD)(ptr - (UCHAR*)buf);
			ptr = (UCHAR*)buf;
			while (!headerDone && (eptr = (LPSTR) memchr((LPCVOID)ptr, '\0', nRead)) != NULL) {
				tstr = (LPSTR)ptr;
				slen = (DWORD)(eptr - tstr);
				nRead -= slen + 1;
				ptr = (UCHAR*)(eptr + 1);
				if (!strcmp((LPCSTR)tstr, "$")) {
					headerDone++;
					break;
				}
				fprintf(stderr, "%s\n", tstr);
			}
			while (nRead > 1 && ptr[0] == 0x3A && (nBytes = ptr[1]) <= (nRead - 6)) {
				ptr += 2;
				page = *ptr++;
				disp = *ptr++;
				sect = *ptr++;
				nRead -= nBytes + 6;					 
				cksum = nBytes;

				switch (sect) {
					case 0:
						fprintf(stderr, "writing %d bytes for address %04x%02x%02x\n", nBytes, map, page, disp);
						toAddr = (map & 0xFFFF) << 16 | (page & 0xFF) << 8 | (disp & 0xFF);
						while (vAddr && (vLen = (toAddr - vAddr))) {
							if (vLen > dummyLen) {
								if (dummy)
									free(dummy);
								dummyLen = (vLen | (BUFSIZE - 1)) + 1;
								dummy = malloc(dummyLen);
								memset(dummy, 0xFF, dummyLen);
							}
							WriteFile(hOut, dummy, vLen, &nWritten, NULL);
							vAddr += nWritten;
						}
						if (!vAddr)
							vAddr = toAddr;
						WriteFile(hOut, ptr, nBytes, &nWritten, NULL);
						vAddr += nWritten;
						break;

					case 1:
						fprintf(stderr, "end of flash file\n");
						break;

					case 2:
						map = (map & 0xFF) | (ptr[1] << 8);
						fprintf(stderr, "setting high map to %02x\n", map >> 8);
						break;

					case 4:
						map = (map & 0xFF00) | (ptr[1] & 0xFF);
						fprintf(stderr, "setting low map to %02x\n", map & 0xFF);
						break;

					default:
						fprintf(stderr, "unhandled section %02x\n", sect);
						break;
				}

				while (nBytes--) {
					cksum += *ptr++;
				}
				cksum += page + disp + sect + *ptr++;

				if (cksum & 0xFF)
					fprintf(stderr, "Bad Checksum !\n");
			}
			if (nRead) {
				memcpy(buf, (LPCVOID)ptr, nRead);
				ptr = (UCHAR*)buf + nRead;
				memset(ptr, 0xFF, BUFSIZE - nRead);
			} else
				ptr = (UCHAR*)buf;
		}

		FlushFileBuffers(hOut);
		FlushFileBuffers(hIn);
		fflush(stderr);

		if (dummy)
			free(dummy);
		if (buf)
			free(buf);
	}

	return nRetCode;
}
